diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
index 2cfc6e101..fedbd41da 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/RenderBlocks.java
@@ -3,9 +3,11 @@ package net.minecraft.client.render.block.model;
 import net.minecraft.client.render.LightingCache;
 import net.minecraft.client.render.LightmapHelper;
 import net.minecraft.core.block.Blocks;
-import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
-import org.lwjgl.opengl.GL11;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.block.color.BlockColorDispatcher;
@@ -15,13 +17,11 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
-import org.jetbrains.annotations.NotNull;
 
 import static net.minecraft.client.render.block.model.BlockModel.FULL_CUBE_THRESHOLD;
 import static net.minecraft.client.render.block.model.BlockModel.SIDE_LIGHT_MULTIPLIER;
 
-public final class RenderBlocks
-{
+public final class RenderBlocks {
     public final Minecraft mc;
     public IconCoordinate overrideBlockTexture;
     public boolean flipTexture;
@@ -54,260 +54,284 @@ public final class RenderBlocks
     public boolean overbright;
     public LightingCache cache = new LightingCache();
 
-    public RenderBlocks()
-    {
-        overrideBlockTexture = null;
-        flipTexture = false;
-        renderAllFaces = false;
-        useInventoryTint = true;
-        uvRotateEast = 0;
-        uvRotateWest = 0;
-        uvRotateSouth = 0;
-        uvRotateNorth = 0;
-        uvRotateTop = 0;
-        uvRotateBottom = 0;
-        renderBitMask = 0;
+    public RenderBlocks() {
+        this.overrideBlockTexture = null;
+        this.flipTexture = false;
+        this.renderAllFaces = false;
+        this.useInventoryTint = true;
+        this.uvRotateEast = 0;
+        this.uvRotateWest = 0;
+        this.uvRotateSouth = 0;
+        this.uvRotateNorth = 0;
+        this.uvRotateTop = 0;
+        this.uvRotateBottom = 0;
+        this.renderBitMask = 0;
         this.mc = Minecraft.getMinecraft();
     }
 
-    public void resetRenderBlocks(){
-        renderAllFaces = false;
-        enableAO = false;
+    public void resetRenderBlocks() {
+        this.renderAllFaces = false;
+        this.enableAO = false;
 //        overbright = false;
-        useInventoryTint = true;
-        flipTexture = false;
-        overrideBlockTexture = null;
-        uvRotateEast = 0;
-        uvRotateWest = 0;
-        uvRotateSouth = 0;
-        uvRotateNorth = 0;
-        uvRotateTop = 0;
-        uvRotateBottom = 0;
-        renderBitMask = 0;
+        this.useInventoryTint = true;
+        this.flipTexture = false;
+        this.overrideBlockTexture = null;
+        this.uvRotateEast = 0;
+        this.uvRotateWest = 0;
+        this.uvRotateSouth = 0;
+        this.uvRotateNorth = 0;
+        this.uvRotateTop = 0;
+        this.uvRotateBottom = 0;
+        this.renderBitMask = 0;
     }
 
-    public void setRenderSide(Side side, boolean shouldRender){
-        if (!shouldRender){
-            renderBitMask |= (byte) (1 << side.getId());
+    public void setRenderSide(@NotNull Side side, boolean shouldRender) {
+        if (!shouldRender) {
+            this.renderBitMask |= (byte) (1 << side.getId());
         } else {
-            renderBitMask &= (byte) ~(1 << side.getId());
+            this.renderBitMask &= (byte) ~(1 << side.getId());
         }
     }
 
-    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z)
-    {
-        if (mc.fullbright) return 1.0f;
-        int id = blockAccess.getBlockId(x, y, z);
-        Block<?> block = blockAccess.getBlock(x, y, z);
-        if (block != null)
-        {
+    @Deprecated
+    public float getBlockBrightness(@NotNull WorldSource worldSource, int x, int y, int z) {
+        return getBlockBrightness(worldSource, new TilePos(x, y, z));
+    }
+
+    public float getBlockBrightness(@NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        if (this.mc.fullbright) return 1.0f;
+        int id = worldSource.getBlockId(tilePos);
+        Block<?> block = worldSource.getBlock(tilePos);
+        if (block != null) {
 
-            return block.getBlockBrightness(blockAccess, x, y, z);
+            return block.getBrightness(worldSource, tilePos);
         }
 
-        return blockAccess.getBrightness(x, y, z, Blocks.lightEmission[id]);
+        return worldSource.getBrightness(tilePos, Blocks.lightEmission[id]);
     }
 
-    public boolean renderStandardBlock(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z)
-    {
-        int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(worldSource, x, y, z, 0);
-        float r = (float)(color >> 16 & 0xff) / 255F;
-        float g = (float)(color >> 8 & 0xff) / 255F;
-        float b = (float)(color & 0xff) / 255F;
-        return renderStandardBlock(tessellator, worldSource, blockModel, bounds, x, y, z, r, g, b);
+    @Deprecated
+    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z) {
+        return renderStandardBlock(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z));
+    }
+
+    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos) {
+        int color = BlockColorDispatcher.getInstance().getDispatch(blockModel.block).getWorldColor(worldSource, tilePos, 0);
+        float r = (float) (color >> 16 & 0xff) / 255F;
+        float g = (float) (color >> 8 & 0xff) / 255F;
+        float b = (float) (color & 0xff) / 255F;
+        return renderStandardBlock(tessellator, worldSource, blockModel, bounds, tilePos, r, g, b);
     }
 
     /**
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public boolean renderStandardBlock(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b) {
+    @Deprecated
+    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b) {
+        return renderStandardBlock(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z), r, g, b);
+    }
+
+    public boolean renderStandardBlock(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b) {
         this.enableAO = true;
-        int meta = worldSource.getBlockMetadata(x, y, z);
-        cache.setupCache(blockModel.block, worldSource, x, y, z);
+        int meta = worldSource.getBlockData(tilePos);
+        this.cache.setupCache(blockModel.block, worldSource, tilePos);
         boolean somethingRendered = false;
-        for (Side side : Side.sides){
-            somethingRendered |= renderSide(tessellator, worldSource, blockModel, bounds, x, y, z, r, g, b, side, meta);
+        for (Side side : Side.sides) {
+            somethingRendered |= renderSide(tessellator, worldSource, blockModel, bounds, tilePos, r, g, b, side, meta);
         }
         this.enableAO = false;
         return somethingRendered;
     }
-    public boolean renderSide(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, Side side, int meta){
+
+    @Deprecated
+    public boolean renderSide(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, int x, int y, int z, float r, float g, float b, @NotNull Side side, int meta) {
+        return renderSide(tessellator, worldSource, blockModel, bounds, new TilePos(x, y, z), r, g, b, side, meta);
+    }
+
+    public boolean renderSide(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds, @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta) {
         boolean useColor;
-        switch (side){
-            case BOTTOM:
-                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
-                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
-                        0, -1, 0, (float)bounds.minY,
-                        0, 0, 1, (float)bounds.maxZ, (float)bounds.minZ,
-                        -1, 0, 0, 1-(float)bounds.minX, 1-(float)bounds.maxX);
-            case TOP:
-                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
-                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
-                        0,1,0, 1-(float)bounds.maxY,
-                        0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
-                        1,0,0, (float)bounds.maxX, (float)bounds.minX);
-            case NORTH:
-                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
-                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
-                        0,0,-1, (float)bounds.minZ,
-                        -1,0,0, 1-(float)bounds.minX, 1-(float)bounds.maxX,
-                        0,1,0, (float)bounds.maxY, (float)bounds.minY);
-            case SOUTH:
-                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
-                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
-                        0,0,1, 1-(float)bounds.maxZ,
-                        0,1,0, (float)bounds.maxY, (float)bounds.minY,
-                        -1,0,0, 1-(float)bounds.minX, 1-(float)bounds.maxX);
-            case WEST:
-                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
-                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
-                        -1,0,0, (float)bounds.minX,
-                        0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
-                        0,1,0, (float)bounds.maxY, (float)bounds.minY);
-            case EAST:
-                useColor = blockModel.shouldSideBeColored(worldSource, x, y, z, side, meta);
-                return renderSide(tessellator, worldSource, blockModel, bounds, x, y, z,
-                        useColor ? r : 1, useColor ? g : 1, useColor ? b : 1,side, meta,
-                        1,0,0, 1-(float)bounds.maxX,
-                        0,0,1, (float)bounds.maxZ, (float)bounds.minZ,
-                        0,-1,0, 1-(float)bounds.minY, 1-(float)bounds.maxY);
-            default:
-                throw new IllegalArgumentException("Side " + side + " not expected!");
-        }
+        return switch (side) {
+            case BOTTOM -> {
+                useColor = blockModel.shouldSideBeColored(worldSource, tilePos, side, meta);
+                yield renderSide(tessellator, worldSource, blockModel, bounds, tilePos,
+                    useColor ? r : 1, useColor ? g : 1, useColor ? b : 1, side, meta,
+                    0, -1, 0, (float) bounds.minY(),
+                    0, 0, 1, (float) bounds.maxZ(), (float) bounds.minZ(),
+                    -1, 0, 0, 1 - (float) bounds.minX(), 1 - (float) bounds.maxX());
+            }
+            case TOP -> {
+                useColor = blockModel.shouldSideBeColored(worldSource, tilePos, side, meta);
+                yield renderSide(tessellator, worldSource, blockModel, bounds, tilePos,
+                    useColor ? r : 1, useColor ? g : 1, useColor ? b : 1, side, meta,
+                    0, 1, 0, 1 - (float) bounds.maxY(),
+                    0, 0, 1, (float) bounds.maxZ(), (float) bounds.minZ(),
+                    1, 0, 0, (float) bounds.maxX(), (float) bounds.minX());
+            }
+            case NORTH -> {
+                useColor = blockModel.shouldSideBeColored(worldSource, tilePos, side, meta);
+                yield renderSide(tessellator, worldSource, blockModel, bounds, tilePos,
+                    useColor ? r : 1, useColor ? g : 1, useColor ? b : 1, side, meta,
+                    0, 0, -1, (float) bounds.minZ(),
+                    -1, 0, 0, 1 - (float) bounds.minX(), 1 - (float) bounds.maxX(),
+                    0, 1, 0, (float) bounds.maxY(), (float) bounds.minY());
+            }
+            case SOUTH -> {
+                useColor = blockModel.shouldSideBeColored(worldSource, tilePos, side, meta);
+                yield renderSide(tessellator, worldSource, blockModel, bounds, tilePos,
+                    useColor ? r : 1, useColor ? g : 1, useColor ? b : 1, side, meta,
+                    0, 0, 1, 1 - (float) bounds.maxZ(),
+                    0, 1, 0, (float) bounds.maxY(), (float) bounds.minY(),
+                    -1, 0, 0, 1 - (float) bounds.minX(), 1 - (float) bounds.maxX());
+            }
+            case WEST -> {
+                useColor = blockModel.shouldSideBeColored(worldSource, tilePos, side, meta);
+                yield renderSide(tessellator, worldSource, blockModel, bounds, tilePos,
+                    useColor ? r : 1, useColor ? g : 1, useColor ? b : 1, side, meta,
+                    -1, 0, 0, (float) bounds.minX(),
+                    0, 0, 1, (float) bounds.maxZ(), (float) bounds.minZ(),
+                    0, 1, 0, (float) bounds.maxY(), (float) bounds.minY());
+            }
+            case EAST -> {
+                useColor = blockModel.shouldSideBeColored(worldSource, tilePos, side, meta);
+                yield renderSide(tessellator, worldSource, blockModel, bounds, tilePos,
+                    useColor ? r : 1, useColor ? g : 1, useColor ? b : 1, side, meta,
+                    1, 0, 0, 1 - (float) bounds.maxX(),
+                    0, 0, 1, (float) bounds.maxZ(), (float) bounds.minZ(),
+                    0, -1, 0, 1 - (float) bounds.minY(), 1 - (float) bounds.maxY());
+            }
+            default -> throw new IllegalArgumentException("Side " + side + " not expected!");
+        };
     }
 
     /**
      * @author CyborgCabbage
      * Thanks! :D
      */
-    public boolean renderSide(Tessellator tessellator, WorldSource worldSource, BlockModelStandard<?> blockModel, AABB bounds, int x, int y, int z, float r, float g, float b, @NotNull Side side, int meta,
+    public boolean renderSide(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull BlockModelStandard<?> blockModel, @NotNull AABBdc bounds,
+                              @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side, int meta,
                               int dirX, int dirY, int dirZ, float depth,
                               int topX, int topY, int topZ, float topP, float botP,
                               int lefX, int lefY, int lefZ, float lefP, float rigP
-    ){
+    ) {
         IconCoordinate tex;
         if (this.overbright) {
-            tex = blockModel.getBlockOverbrightTexture(worldSource, x, y, z, side);
+            tex = blockModel.getBlockOverbrightTexture(worldSource, tilePos, side);
         } else {
-            tex = blockModel.getBlockTexture(worldSource, x, y, z, side);
+            tex = blockModel.getBlockTexture(worldSource, tilePos, side);
         }
-        if (tex == null || ((renderBitMask >> side.getId()) & 1) != 0) return false;
+        if (tex == null || ((this.renderBitMask >> side.getId()) & 1) != 0) return false;
 
         boolean rendered = false;
-        if (this.renderAllFaces || blockModel.shouldSideBeRendered(worldSource, bounds, x+dirX, y+dirY, z+dirZ, side, meta)) {
-        	
-            setupLighting(blockModel.block, worldSource, x, y, z, r, g, b, side,
+        if (this.renderAllFaces || blockModel.shouldSideBeRendered(worldSource, bounds, tilePos.add(dirX, dirY, dirZ, new TilePos()), side, meta)) {
+
+            setupLighting(worldSource, blockModel.block, tilePos, r, g, b, side,
                 dirX, dirY, dirZ, depth,
-                    topX, topY, topZ, topP, botP,
-                    lefX, lefY, lefZ, lefP, rigP);
+                topX, topY, topZ, topP, botP,
+                lefX, lefY, lefZ, lefP, rigP);
 
             switch (side) {
                 case BOTTOM:
-                    this.renderBottomFace(tessellator, bounds, x, y, z, tex);
+                    this.renderBottomFace(tessellator, bounds, tilePos, tex);
                     break;
                 case TOP:
-                    this.renderTopFace(tessellator, bounds, x, y, z, tex);
+                    this.renderTopFace(tessellator, bounds, tilePos, tex);
                     break;
                 case NORTH:
-                    this.renderNorthFace(tessellator, bounds, x, y, z, tex);
+                    this.renderNorthFace(tessellator, bounds, tilePos, tex);
                     break;
                 case SOUTH:
-                    this.renderSouthFace(tessellator, bounds, x, y, z, tex);
+                    this.renderSouthFace(tessellator, bounds, tilePos, tex);
                     break;
                 case WEST:
-                    this.renderWestFace(tessellator, bounds, x, y, z, tex);
+                    this.renderWestFace(tessellator, bounds, tilePos, tex);
                     break;
                 case EAST:
-                    this.renderEastFace(tessellator, bounds, x, y, z, tex);
+                    this.renderEastFace(tessellator, bounds, tilePos, tex);
                     break;
             }
             rendered = true;
         }
         return rendered;
     }
-    public void setupLighting(Block<?> block, WorldSource worldSource, int x, int y, int z, float r, float g, float b, @NotNull Side side,
+
+    public void setupLighting(@NotNull WorldSource worldSource, @NotNull Block<?> block, @NotNull TilePosc tilePos, float r, float g, float b, @NotNull Side side,
                               int dirX, int dirY, int dirZ, float depth,
                               int topX, int topY, int topZ, float topP, float botP,
-                              int lefX, int lefY, int lefZ, float lefP, float rigP){
-    	boolean ao = mc.isAmbientOcclusionEnabled() && block.emission == 0;
+                              int lefX, int lefY, int lefZ, float lefP, float rigP) {
+        boolean ao = this.mc.isAmbientOcclusionEnabled() && block.emission == 0;
         boolean isFullCube = depth <= FULL_CUBE_THRESHOLD;
 
-    	if(LightmapHelper.isLightmapEnabled()) {
-    		if(overbright) {
-    			int dirX2 = dirX;
-    			int dirY2 = dirY;
-    			int dirZ2 = dirZ;
-    			
-    			if(!isFullCube) {
-    				dirX2 = 0;
-    				dirY2 = 0;
-    				dirZ2 = 0;
-    			}
-    			
-    			int lmc = LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
-    			
-        		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
-    		}else {
-        		if(ao) {
-        			int dirX2 = dirX;
-        			int dirY2 = dirY;
-        			int dirZ2 = dirZ;
-        			
-        			if(!isFullCube) {
-        				dirX2 = 0;
-        				dirY2 = 0;
-        				dirZ2 = 0;
-        			}
-        			
-        			boolean topT = cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-        			boolean botT = cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-        			boolean lefT = cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-        			boolean rigT = cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-        			
-        			boolean topLefT = cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
-        			boolean topRigT = cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
-        			boolean botLefT = cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
-        			boolean botRigT = cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
-        			
-        			int lmcCen = cache.getLightmapCoord(dirX2, dirY2, dirZ2);
-        			
-        			int lmcTop = topT ? lmcCen : cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
-        			int lmcBot = botT ? lmcCen : cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
-        			int lmcLef = lefT ? lmcCen : cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
-        			int lmcRig = rigT ? lmcCen : cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
-
-        			int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
-        			int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
-        			int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
-        			int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
-
-        			lightmapCoordTopLeft     = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
-        			lightmapCoordTopRight    = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
-        			lightmapCoordBottomLeft  = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
-        			lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
-        		}else {
-        			int lmc;
-                	if(!isFullCube) {
-                		lmc = block.getLightmapCoord(worldSource, x, y, z);
-                	}else {
-                		lmc = block.getLightmapCoord(worldSource, x + dirX, y + dirY, z + dirZ);
-                	}
-            		lightmapCoordTopLeft = lightmapCoordBottomLeft = lightmapCoordBottomRight = lightmapCoordTopRight = lmc;
-        		}
-    		}
-    	}
-    	
+        if (LightmapHelper.isLightmapEnabled()) {
+            if (this.overbright) {
+                int dirX2 = dirX;
+                int dirY2 = dirY;
+                int dirZ2 = dirZ;
+
+                if (!isFullCube) {
+                    dirX2 = 0;
+                    dirY2 = 0;
+                    dirZ2 = 0;
+                }
+
+                int lmc = LightmapHelper.getOverbrightLightmapCoord(worldSource.getSavedLightValue(LightLayer.Sky, dirX2, dirY2, dirZ2));
+
+                this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+            } else {
+                if (ao) {
+                    int dirX2 = dirX;
+                    int dirY2 = dirY;
+                    int dirZ2 = dirZ;
+
+                    if (!isFullCube) {
+                        dirX2 = 0;
+                        dirY2 = 0;
+                        dirZ2 = 0;
+                    }
+
+                    boolean topT = this.cache.getOpacity(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+                    boolean botT = this.cache.getOpacity(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+                    boolean lefT = this.cache.getOpacity(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+                    boolean rigT = this.cache.getOpacity(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+
+                    boolean topLefT = this.cache.getOpacity(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ);
+                    boolean topRigT = this.cache.getOpacity(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ);
+                    boolean botLefT = this.cache.getOpacity(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ);
+                    boolean botRigT = this.cache.getOpacity(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ);
+
+                    int lmcCen = this.cache.getLightmapCoord(dirX2, dirY2, dirZ2);
+
+                    int lmcTop = topT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX, dirY2 + topY, dirZ2 + topZ);
+                    int lmcBot = botT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX, dirY2 - topY, dirZ2 - topZ);
+                    int lmcLef = lefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + lefX, dirY2 + lefY, dirZ2 + lefZ);
+                    int lmcRig = rigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - lefX, dirY2 - lefY, dirZ2 - lefZ);
+
+                    int lmcTopLef = topT && lefT ? lmcLef : (topLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX + lefX, dirY2 + topY + lefY, dirZ2 + topZ + lefZ));
+                    int lmcBotLef = botT && lefT ? lmcLef : (botLefT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX + lefX, dirY2 - topY + lefY, dirZ2 - topZ + lefZ));
+                    int lmcTopRig = topT && rigT ? lmcRig : (topRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 + topX - lefX, dirY2 + topY - lefY, dirZ2 + topZ - lefZ));
+                    int lmcBotRig = botT && rigT ? lmcRig : (botRigT ? lmcCen : this.cache.getLightmapCoord(dirX2 - topX - lefX, dirY2 - topY - lefY, dirZ2 - topZ - lefZ));
+
+                    this.lightmapCoordTopLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcTop, lmcTopLef);
+                    this.lightmapCoordTopRight = LightmapHelper.avg(lmcCen, lmcRig, lmcTop, lmcTopRig);
+                    this.lightmapCoordBottomLeft = LightmapHelper.avg(lmcCen, lmcLef, lmcBot, lmcBotLef);
+                    this.lightmapCoordBottomRight = LightmapHelper.avg(lmcCen, lmcRig, lmcBot, lmcBotRig);
+                } else {
+                    int lmc;
+                    if (!isFullCube) {
+                        lmc = block.getLightmapCoord(worldSource, tilePos);
+                    } else {
+                        lmc = block.getLightmapCoord(worldSource, tilePos.add(dirX, dirY, dirZ, new TilePos()));
+                    }
+                    this.lightmapCoordTopLeft = this.lightmapCoordBottomLeft = this.lightmapCoordBottomRight = this.lightmapCoordTopRight = lmc;
+                }
+            }
+        }
+
         float lightTR;
         float lightBR;
         float lightBL;
         float lightTL;
-    	
+
         if (this.overbright) {
             lightTR = 1.0F;
             lightBR = 1.0F;
